<template>
	<v-card class="tableCard" flat>
		<v-card-title>
			<v-text-field v-model="search" append-icon="mdi-magnify" label="Search jobs..." single-line hide-details />
		</v-card-title>

		<v-data-table
			class="stratificationJobsTable"
			:headers="headers"
			:items="tableData"
			:loading="isLoading"
			:search="search"
			:page.sync="page"
			loading-text="Loading stratification jobs..."
			multi-sort
			:sort-by.sync="sortBy"
			:sort-desc.sync="sortDesc"
			:no-data-text="
				error ? 'There was an error loading stratification jobs. Please refresh.' : 'No stratification jobs, yet.'
			"
		>
			<template slot="item.lastUpdated" slot-scope="props">
				{{ new Date(props.item.lastUpdated).toLocaleString() }}
			</template>
			<template slot="item.actions" slot-scope="props">
				<div class="actionWrapper">
					<v-btn :key="item.text" v-for="item in props.item.actions" small @click="item.handler">{{ item.text }}</v-btn>
				</div>
			</template>

			<template v-slot:item.autoApprove="{ item }">
				<v-simple-checkbox v-model="item.autoApprove" disabled></v-simple-checkbox>
			</template>

			<template slot="item.error" slot-scope="props">
				<v-dialog v-if="props.item.error" :v-model="props.item.isErrorOpen" width="50em">
					<template v-slot:activator="{ on, attrs }">
						<v-btn small depressed v-bind="attrs" v-on="on"> View Error </v-btn>
					</template>
					<v-card>
						<v-card-title> Error Message </v-card-title>
						<v-card-text>
							<pre>{{ props.item.error }}</pre>
						</v-card-text>
					</v-card>
				</v-dialog>
			</template>

			<template slot="item.stratificationConfigDialog" slot-scope="props">
				<v-dialog :v-model="props.item.isStratificationConfigDialogOpen" width="50em">
					<template v-slot:activator="{ on, attrs }">
						<v-btn small depressed v-bind="attrs" v-on="on"> View Config </v-btn>
					</template>
					<v-card>
						<v-card-title> Stratification Configuration </v-card-title>
						<v-card-text>
							<pre>{{ props.item.stratificationConfig }}</pre>
						</v-card-text>
					</v-card>
				</v-dialog>
			</template>
		</v-data-table>

		<confirm-dialog
			key="approve"
			:value="isApproveDialogOpen"
			title="Approve Stratification"
			:error="approveDialogHasError ? 'There was an error approving the stratification. Please try again.' : undefined"
			:loading="approveDialogIsLoading"
			button="Confirm"
			button-color="primary"
			persistent
			@confirm="handleConfirmApprove"
			@cleanup="clearApproveDialogError"
			@input="
				($event) => {
					if ($event === false) clearApproveDialogError();
				}
			"
			:message="`Are you sure you want to approve this stratification`"
		></confirm-dialog>
		<confirm-dialog
			key="cancel"
			:value="isCancelDialogOpen"
			:title="`Dismiss Stratification Job`"
			:error="cancelDialogHasError ? 'There was an error dismissing the job. Please try again.' : undefined"
			:loading="cancelDialogIsLoading"
			button="Dismiss Job"
			button-color="warning"
			persistent
			@confirm="handleConfirmCancel"
			@cleanup="clearCancelDialogError"
			@input="
				($event) => {
					if ($event === false) clearCancelDialogError();
				}
			"
			:message="`Are you sure you want to dismiss stratification job ${cancelDialogOpenFor}? This action cannot be undone.`"
		></confirm-dialog>
		<v-dialog :value="isReviewDialogOpen" fullscreen>
			<review-stratification-job
				v-if="stratificationJobUnderReview"
				:stratificationJob="stratificationJobUnderReview"
				@submitted="handleReviewSubmitted"
				@cancel="handleReviewCancel"
			/>
		</v-dialog>
	</v-card>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from '@vue/composition-api';
import { DataTableHeader } from 'vuetify';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { useGroups } from '@/store/modules/group';
import { useAllResources } from '@/store/modules/resources';
import ReviewStratificationJob from '@/views/stratify/ReviewStratificationJob.vue';
import soilApiService from '../../services/soilApiService';

interface StratificationJobsTableRow {
	fieldName: string;
	groupName: string;
	stratificationConfig: string;
	status: string;
	lastUpdated: string | null;
}

const formattedClosedReason = {
	APPROVED: 'Approved',
	REJECTED: 'Rejected',
	CANCELLED: 'Dismissed',
	TIMED_OUT: 'Timed Out',
	FAILED_TO_CREATE: 'Failed to Create',
};

const formattedExternalJobStatus = {
	SUCCESS: 'Success',
	FAILURE: 'Failed',
	PENDING: 'Pending',
};

const useStratificationJobs = () => {
	const isLoading = ref<boolean>(true);
	const stratificationJobs = ref<any[]>([]);
	const error = ref<any>(null);

	soilApiService
		.getStratificationJobs()
		.then((response) => {
			stratificationJobs.value = response.data;
		})
		.catch((err) => {
			error.value = err;
		})
		.finally(() => {
			isLoading.value = false;
		});

	return {
		isLoading,
		stratificationJobs,
		error,
	};
};

const getDisplayStatus = (stratificationJob: any) => {
	if (stratificationJob.isClosed) {
		return (formattedClosedReason as any)[stratificationJob.closedReason];
	} else {
		if (stratificationJob.externalJobStatus === 'SUCCESS') {
			return 'Awaiting Review';
		} else {
			return (formattedExternalJobStatus as any)[stratificationJob.externalJobStatus];
		}
	}
};

const getActions = (
	stratificationJob: any,
	cancelDialogOpenFor: any,
	stratificationJobUnderReview: any,
	approveDialogOpenFor: any
) => {
	if (stratificationJob.isClosed) {
		return [];
	}
	if (stratificationJob.externalJobStatus === 'SUCCESS') {
		return [
			{
				text: 'Review',
				handler: () => {
					stratificationJobUnderReview.value = stratificationJob;
				},
			},
			{
				text: 'Dismiss',
				handler: () => {
					cancelDialogOpenFor.value = stratificationJob.id;
				},
			},
			{
				text: 'Approve',
				handler: () => {
					approveDialogOpenFor.value = stratificationJob.id;
				},
			},
		];
	} else {
		return [
			{
				text: 'Dismiss',
				handler: () => {
					cancelDialogOpenFor.value = stratificationJob.id;
				},
			},
		];
	}
};

export default defineComponent({
	components: {
		ConfirmDialog,
		ReviewStratificationJob,
	},
	setup(_, { root }) {
		const search = ref<string>('');
		const page = ref<number>(1);
		const sortBy = ref<string[]>(['lastUpdated']);
		const sortDesc = ref<boolean[]>([true]);
		const { isLoading: jobsAreLoading, error: jobsHaveError, stratificationJobs } = useStratificationJobs();
		const { isLoading: areGroupsLoading, hasError: groupsHaveError } = useGroups(root.$store);
		const { isLoading: areResourcesLoading, isLoaded: areResourcesLoaded } = useAllResources(root.$store);
		const isLoading = computed<boolean>(
			() => jobsAreLoading.value || areGroupsLoading.value || areResourcesLoading.value
		);
		const error = computed<any>(() => jobsHaveError.value || groupsHaveError.value);
		const cancelDialogOpenFor = ref<string | null>(null);
		const cancelDialogIsLoading = ref<boolean>(false);
		const cancelDialogHasError = ref<boolean>(false);
		const isCancelDialogOpen = computed<boolean>(() => cancelDialogOpenFor.value !== null);
		const approveDialogOpenFor = ref<string | null>(null);
		const approveDialogIsLoading = ref<boolean>(false);
		const approveDialogHasError = ref<boolean>(false);
		const isApproveDialogOpen = computed<boolean>(() => approveDialogOpenFor.value !== null);
		const stratificationJobUnderReview = ref<any>(null);
		const isReviewDialogOpen = computed<boolean>(() => stratificationJobUnderReview.value !== null);
		const refreshJobs = () =>
			soilApiService
				.getStratificationJobs()
				.then((response) => {
					stratificationJobs.value = response.data;
				})
				.catch((err) => {
					jobsHaveError.value = err;
				})
				.finally(() => {
					jobsAreLoading.value = false;
				});

		const headers: DataTableHeader[] = [
			{ text: 'Field Name', value: 'fieldName' },
			{ text: 'Group', value: 'groupName' },
			{ text: 'Configuration', value: 'stratificationConfigDialog', sortable: false },
			{ text: 'Status', value: 'status' },
			{ text: 'Last Updated', value: 'lastUpdated' },
			{ text: 'Auto Approve', value: 'autoApprove' },
			{ text: 'Error', value: 'error', sortable: false },
			{ text: '', value: 'actions', sortable: false },
		];

		const tableData = computed<StratificationJobsTableRow[]>(() =>
			areResourcesLoaded.value
				? stratificationJobs.value.map((stratificationJob) => {
						const field = root.$store.getters['resources/getFieldByAreaId'](stratificationJob.areaId);

						return {
							fieldName: field?.name,
							groupName: root.$store.getters['groups/getGroupNameById'](field.meta.groupId),
							stratificationConfig: JSON.stringify(JSON.parse(stratificationJob.stratificationConfig), null, 2),
							status: getDisplayStatus(stratificationJob),
							lastUpdated: stratificationJob.updatedAt,
							error: stratificationJob.error,
							actions: getActions(
								stratificationJob,
								cancelDialogOpenFor,
								stratificationJobUnderReview,
								approveDialogOpenFor
							),
							isStratificationConfigDialogOpen: ref<boolean>(false),
							isErrorOpen: ref<boolean>(false),
							autoApprove: stratificationJob.autoApprove,
						};
				  })
				: []
		);

		const clearCancelDialogError = () => {
			cancelDialogHasError.value = false;
			cancelDialogOpenFor.value = null;
		};

		const handleConfirmCancel = async () => {
			try {
				cancelDialogIsLoading.value = true;
				await soilApiService.closeStratificationJob(cancelDialogOpenFor.value as string, 'CANCELLED');
				cancelDialogOpenFor.value = null;
				refreshJobs();
			} catch (error) {
				cancelDialogHasError.value = true;
			} finally {
				cancelDialogIsLoading.value = false;
			}
		};

		const clearApproveDialogError = () => {
			approveDialogHasError.value = false;
			approveDialogOpenFor.value = null;
		};

		const handleConfirmApprove = async () => {
			try {
				approveDialogIsLoading.value = true;
				await soilApiService.closeStratificationJob(approveDialogOpenFor.value as string, 'APPROVED');
				approveDialogOpenFor.value = null;
				refreshJobs();
			} catch (error) {
				approveDialogHasError.value = true;
			} finally {
				approveDialogIsLoading.value = false;
			}
		};

		const handleReviewSubmitted = () => {
			stratificationJobUnderReview.value = null;
			refreshJobs();
			root.$store.dispatch('resources/getAllResources');
		};

		const handleReviewCancel = () => {
			stratificationJobUnderReview.value = null;
		};

		watch(search, () => (page.value = 1));

		return {
			search,
			page,
			sortBy,
			sortDesc,
			headers,
			tableData,
			error,
			isLoading,
			cancelDialogOpenFor,
			isCancelDialogOpen,
			cancelDialogIsLoading,
			cancelDialogHasError,
			clearCancelDialogError,
			handleConfirmCancel,
			approveDialogOpenFor,
			isApproveDialogOpen,
			approveDialogIsLoading,
			approveDialogHasError,
			clearApproveDialogError,
			handleConfirmApprove,
			stratificationJobs,
			stratificationJobUnderReview,
			isReviewDialogOpen,
			handleReviewSubmitted,
			handleReviewCancel,
		};
	},
});
</script>

<style lang="scss">
.stratificationJobsTable.v-data-table table > tbody > tr {
	td:nth-last-child(2) {
		width: 160px;
		font-size: 0.75rem;
	}

	td:last-child {
		width: 200px;

		.actionWrapper {
			display: flex;
			gap: 8px;
		}
	}
}
</style>
